let m_map;
let m_view;
let m_drawtool;
let isSetMapZoom;
let geometryService;
let GraphicsLayer_labelLayer;
let GraphicsLayer_myLayer;
let GraphicsLayer_identityLayer;
let GraphicsLayer_extendLayer;
let GraphicsLayer_fickerLayer;
let GraphicsLayer_DrawLayer;
let GraphicsLayer_flyTipLayer;

let highlightSelect;
let highlightSelectExtra;
function initMap() {
    currentMapMode = "2D";
    require(["esri/Map", "esri/views/MapView", "esri/layers/MapImageLayer", "esri/layers/TileLayer", "esri/layers/VectorTileLayer","esri/geometry/Geometry", "esri/geometry/Extent",
            "esri/tasks/GeometryService", "esri/layers/GraphicsLayer", "esri/layers/FeatureLayer", "esri/widgets/ScaleBar",
            "esri/WebMap", "esri/geometry/SpatialReference", "esri/Graphic", "esri/views/2d/draw/Draw",
            "esri/geometry/Polygon", "esri/widgets/Zoom", "esri/widgets/Compass", "esri/widgets/LayerList","esri/widgets/Legend",
            "esri/widgets/Expand",
            "esri/geometry/geometryEngine","esri/tasks/QueryTask", "esri/tasks/support/Query",
            "esri/geometry/Point","esri/widgets/AreaMeasurement2D","esri/widgets/DistanceMeasurement2D",
            "esri/core/watchUtils","dojo/on"],
        function(Map, MapView, MapImageLayer, TileLayer,VectorTileLayer, Geometry, Extent, GeometryService,
                 GraphicsLayer, FeatureLayer, ScaleBar, WebMap, SpatialReference, Graphic, Draw, Polygon,
                 Zoom, Compass, LayerList, Legend, Expand, geometryEngine,QueryTask,Query,Point,AreaMeasurement2D,DistanceMeasurement2D,watchUtils,on) {
            //esriConfig.request.trustedServers.push("[https//]map.shanghai-map.net[:443]");
            m_map = new Map({
                logo:false,
                slider:false
            });
            var mapXml = getConfigByName("map");
            dyAddMapLayerByConfig();
            AddMapGraphicLayers();

            viewxmax =mapXml.viewxmax;
            viewxmin = mapXml.viewxmin;
            viewymax = mapXml.viewymax;
            viewymin = mapXml.viewymin;

            m_view = new MapView({
                container: "mapDiv",
                map: m_map,
                popup: {
                    dockEnabled: false,
                    dockOptions: {
                        position: "top-right",
                        breakpoint: false
                    }
                }
            });
            m_view.constraints = {
                rotationEnabled: false  // Disables map rotation
            };

            layerList = new LayerList({
                view: m_view
            });
            AddSceneViewWidget();
            m_view.when(function(evt) {

                // m_view.ui.add("info", "top-right");
                //doToolTip();
                var displaynoneDiv1 = document.getElementsByClassName("esri-attribution__powered-by");
                for (var i = 0; i < displaynoneDiv1.length; i++) {
                    displaynoneDiv1[i].style.display = "none"
                }
                var displaynoneDiv2 = document.getElementsByClassName("esri-widget-button");
                for (var i = 0; i < displaynoneDiv2.length; i++) {
                    displaynoneDiv2[i].style.display = "none"
                }
                m_zoom = new Zoom({
                    view: m_view
                });
                // m_view.ui.add(m_zoom, {
                //     position: "top-right"
                // });
                m_view.ui.move([ "zoom", m_zoom ], "top-right");
                var m_compass = new Compass({
                    view: m_view
                });
                m_view.ui.add(m_compass, {
                    position: "top-right"
                });
                //m_view.ui.remove('zoom');
                m_view.ui.remove('attribution');
                m_drawtool = new Draw({
                    view: m_view
                })

                var centerx = m_view.center.x;
                var centery = m_view.center.y;
                // m_view.on("resize",function (event) {
                //
                // });
                var infoDiv = document.getElementById("infoDiv");
                m_view.ui.add(
                    new Expand({
                        view: m_view,
                        content: infoDiv,
                        expandIconClass: "esri-icon-layer-list",
                        expanded: false
                    }),
                    "top-right"
                );

                // var legend = new Legend({
                //     view: m_view,
                //     container: "legendDiv",
                //
                // });

                m_view.watch("animation", function(response){
                    if(response && response.state === "running"){
                        // console.log("Animation in progress");
                        window.parent.postMessage(
                            {
                                method: "mapAnimationInProgressCallback"
                            },
                            '*'
                        );
                    }

                });
                m_view.watch("extent", updateIndicator);
                function updateIndicator(extent) {
                    //console.log("xmin:"+extent.xmin+",ymin:"+extent.ymin+",xmax:"+extent.xmax+",ymax:"+extent.ymax);
                }


                m_view.on("drag",function (event) {
                    if(event.action == 'end'){
                        // event.startPropagation();
                    }
                    else{
                        // console.log("drag in progress");
                        window.parent.postMessage(
                            {
                                method: "mapDragingCallback"
                            },
                            '*'
                        );
                    }
                });

                // onMapLoadInfo();
                // dyAddMapLayerByConfig();
                // AddMapGraphicLayers();

                //初始化范围
                m_view.extent=new Extent({xmin: -16554.418188244,
                    ymin: -7094.805964119,
                    xmax: -989.488316467361,
                    ymax: 1858.0534151078832,
                    spatialReference:m_view.spatialReference});
            });
            var scaleBar = new ScaleBar({
                view: m_view
            });
            // m_view.ui.add(scaleBar, {
            //     position: "bottom-left"
            // });



            function dyAddMapLayerByConfig() {
                var serverUrl;
                var serverType;
                var serverLabel;
                var serverVisible;

                var mapNodes = mapXml;
                for (var i in mapNodes) {
                    var value = mapNodes[i];

                    if (i == "geometryservice") {
                        serverType = "geometryservice";
                        serverUrl = value;
                        dyAddMapLayer(serverUrl, serverType, serverLabel, serverVisible)
                    } else if (i == "fullextent") {
                        var extentArray = value;
                        fullExtent = new Extent(parseFloat(extentArray[0]), parseFloat(extentArray[1]), parseFloat(extentArray[2]), parseFloat(extentArray[3]))
                    } else if (i == "basemaps") {

                        var childNodes = value;
                        for (var j = 0; j < childNodes.length; j++) {
                            var childNode = childNodes[j].Layer;
                            for (var k in childNode) {

                                var attribute = childNode[k];
                                var attributeName = k;
                                if (attributeName == "label") {
                                    serverLabel = attribute;
                                }
                                if (attributeName == "type") {
                                    serverType = attribute;
                                }
                                if (attributeName == "visible") {
                                    if (attribute == "false") serverVisible = false;
                                    else serverVisible = true;
                                }
                                if(attributeName=="url"){
                                    serverUrl = attribute;
                                }
                            }

                            dyAddMapLayer(serverUrl, serverType, serverLabel, serverVisible)

                        }
                    }

                }
            }
            function dyAddMapLayer(serverUrl, serverType, serverLabel, serverVisible) {
                var layer;
                switch (serverType) {
                    case "geometryservice":
                    {
                        //geometryService = new geometryService(serverUrl);
                        break;
                    }
                    case "tiled":
                    {
                        layer = new TileLayer({
                            url: serverUrl,
                            id: serverLabel
                        });
                        layer.visible = serverVisible;
                        m_map.add(layer);
                        layer.when(function () {
                            onMapLoadInfo();
                        })
                        break;
                    }
                    case "dynamic":
                    {
                        if (serverLabel == "卫监所动态数据") {
                            layer = new MapImageLayer({
                                url: serverUrl,
                                sublayers: [{
                                    id: 0,
                                    popupTemplate: {
                                        title: "{COUNTY}",
                                        content: "{POP2007} people lived in this county in 2007"
                                    }
                                },
                                    {
                                        id: 1,
                                        popupTemplate: {
                                            title: "{COUNTY}",
                                            content: "{POP2007} people lived in this county in 2007"
                                        }
                                    }]
                            });
                        } else {

                            dyLayer = new MapImageLayer({
                                url: serverUrl,
                                id: serverLabel
                            });
                            dyLayer.visible = serverVisible;
                        }
                        m_map.add(dyLayer);
                        on(dyLayer, "load",
                            function(evt) {
                                dynamicLayerLoaded(evt)
                            });
                        dyLayer.when(function() {
                            var layerInfo = GetDynamicServiceLayer();
                            for (var i = 0; i < layerInfo.length; i++) {
                                GetLayerRestData(i)
                            }
                        });
                        break;
                    }
                    case "featurelayer":
                    {
                        var restUrl = serverUrl + "?f=pjson";
                        var xmlHttpRest = GetXmlHttpObject();
                        xmlHttpRest.open("GET", restUrl, true);
                        xmlHttpRest.send();
                        xmlHttpRest.onreadystatechange = function() {
                            var responseText = xmlHttpRest.responseText;
                            if (xmlHttpRest.readyState == 4) {
                                var LayerJsonData = JSON.parse(responseText);
                                if (LayerJsonData != "") {
                                    var layers = LayerJsonData.layers;
                                    if (layers.length > 0) {
                                        for (var i = 0; i < layers.length; i++) {
                                            if (layers[i].subLayerIds == null) {
                                                var layerId = layers[i].id;
                                                var layername = layers[i].name;
                                                if(layername)
                                                    var dyLayer = new FeatureLayer({
                                                        url: serverUrl+"/"+layerId,
                                                        id: layerId
                                                    });
                                                dyLayer.visible = serverVisible;
                                                // if(layername == "上水井盖")
                                                //     dyLayer.visible = true;
                                                m_map.add(dyLayer);
                                            }
                                        }
                                    }
                                }
                            }
                        }
                        break;
                    }
                    case "vector":
                    {
                        var vlayer = new VectorTileLayer({
                            url: serverUrl,
                            id: serverLabel
                        });
                        m_map.add(vlayer);
                        break;
                    }
                }
            }
            function dynamicLayerLoaded(event) {
                //m_view.zoom = 2;
            }
            function AddMapGraphicLayers() {
                GraphicsLayer_labelLayer = new GraphicsLayer({id:"myLabelGLayer"});
                GraphicsLayer_labelLayer.listMode = "hide";
                GraphicsLayer_myLayer = new GraphicsLayer({id:"myGLayer"});
                GraphicsLayer_myLayer.listMode = "hide";
                GraphicsLayer_identityLayer = new GraphicsLayer;
                GraphicsLayer_identityLayer.listMode = "hide";
                GraphicsLayer_extendLayer = new GraphicsLayer;
                GraphicsLayer_extendLayer.listMode = "hide";
                GraphicsLayer_fickerLayer = new GraphicsLayer;
                GraphicsLayer_fickerLayer.listMode = "hide";
                GraphicsLayer_DrawLayer = new GraphicsLayer({id:"myDrawGLayer"});
                GraphicsLayer_DrawLayer.listMode = "hide";
                GraphicsLayer_flyTipLayer = new GraphicsLayer;
                GraphicsLayer_flyTipLayer.listMode = "hide";
                m_map.add(GraphicsLayer_labelLayer);
                m_map.add(GraphicsLayer_identityLayer);
                m_map.add(GraphicsLayer_DrawLayer);
                m_map.add(GraphicsLayer_flyTipLayer);
                m_map.add(GraphicsLayer_myLayer);
                m_map.add(GraphicsLayer_extendLayer);
                m_map.add(GraphicsLayer_fickerLayer);

            }
            function AddSceneViewWidget() {
                // var viewTest = document.getElementById("viewTest");
                // m_view.ui.add(viewTest, "top-left");
            }



        });
}

function initTDMap() {
    require([
        "esri/Map",
        "esri/layers/WebTileLayer",
        'esri/layers/support/TileInfo',
        'esri/views/MapView',
        "esri/layers/FeatureLayer",
        "esri/layers/GraphicsLayer",
        "esri/widgets/Zoom",
        "esri/views/2d/draw/Draw",
        "esri/geometry/SpatialReference",
        "esri/geometry/Point",

    ], function (Map, WebTileLayer, TileInfo, MapView, FeatureLayer,GraphicsLayer, Zoom,Draw,SpatialReference, Point) {

        var tiandituBaseUrl = "http://{subDomain}.tianditu.com"; //天地图服务地址
        var token = "2ad67ff89a7e0e340e36de6b6f375997"; //天地图token，在官网申请
        var tileInfo = new TileInfo({
            "width": 256,
            "height": 256,
            "compressionQuality": 0,
            "origin": {
                "x": -180,
                "y": 90
            },
            "spatialReference": {
                "wkid": 4490
            },
            "lods": [
                { "level": "1", "scale": 295829355.45, "resolution": 0.703125 },
                { "level": "2", "scale": 147914677.725, "resolution": 0.3515625 },
                { "level": "3", "scale": 73957338.8625, "resolution": 0.17578125 },
                { "level": "4", "scale": 36978669.43125, "resolution": 0.087890625 },
                { "level": "5", "scale": 18489334.715625, "resolution": 0.0439453125 },
                { "level": "6", "scale": 9244667.3578125, "resolution": 0.02197265625 },
                { "level": "7", "scale": 4622333.67890625, "resolution": 0.010986328125 },
                { "level": "8", "scale": 2311166.839453125, "resolution": 0.0054931640625 },
                { "level": "9", "scale": 1155583.4197265625, "resolution": 0.00274658203125 },
                { "level": "10", "scale": 577791.7098632812, "resolution": 0.001373291015625 },
                { "level": "11", "scale": 288895.8549316406, "resolution": 0.0006866455078125 },
                { "level": "12", "scale": 144447.9274658203, "resolution": 0.00034332275390625 },
                { "level": "13", "scale": 72223.96373291015, "resolution": 0.000171661376953125 },
                { "level": "14", "scale": 36111.98186645508, "resolution": 0.0000858306884765625 },
                { "level": "15", "scale": 18055.99093322754, "resolution": 0.00004291534423828125 },
                { "level": "16", "scale": 9027.99546661377, "resolution": 0.000021457672119140625 },
                { "level": "17", "scale": 4513.997733306885, "resolution": 0.000010728836059570312 },
                { "level": "18", "scale": 2256.9988666534423, "resolution": 0.000005364418029785156 }
            ]
        })

        //影像地图（wkid4490：CGCS2000)
        var tiledLayer = new WebTileLayer({
            urlTemplate: tiandituBaseUrl + "/DataServer?T=img_c&x={col}&y={row}&l={level}&tk=" + token,
            subDomains: ["t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7"],
            tileInfo: tileInfo,
            spatialReference: { wkid: 4490 },
        });

        //矢量切片（wkid4490：CGCS2000)
        var tiledLayerJC = new WebTileLayer({
            urlTemplate: tiandituBaseUrl + "/DataServer?T=vec_c&x={col}&y={row}&l={level}&tk=" + token,
            subDomains: ["t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7"],
            tileInfo: tileInfo,
            spatialReference: { wkid: 4490 },
        });

        //影像注记
        var tiledLayerAnno = new WebTileLayer({
            urlTemplate: tiandituBaseUrl + "/DataServer?T=cia_c&x={col}&y={row}&l={level}&tk=" + token,
            subDomains: ["t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7"],
            tileInfo: tileInfo,
            spatialReference: { wkid: 4490 },
        });

        //影像注记
        let tiledLayerAnnoJC = new WebTileLayer({
            urlTemplate: tiandituBaseUrl + "/DataServer?T=cva_c&x={col}&y={row}&l={level}&tk=" + token,
            subDomains: ["t0", "t1", "t2", "t3", "t4", "t5", "t6", "t7"],
            tileInfo: tileInfo,
            spatialReference: { wkid: 4490 },
        });
        //定位到三亚市中心
        //var cityCenter = new Point(109.507, 18.256, new SpatialReference({ wkid: 4490 }));
        //定位到上海
        let cityCenter = new Point(121.472, 31.233, new SpatialReference({ wkid: 4490 }));
        // 创建地图
        m_map = new Map({
            basemap: {
                baseLayers: [tiledLayerJC, tiledLayerAnnoJC]
            },
            logo:false,
            slider:true
        });
        AddMapGraphicLayers();

        m_view = new MapView({
            container: "mapDiv",
            map: m_map,
            center: cityCenter,
            zoom: 9,
        });

        m_view.when(function(evt) {
            let displaynoneDiv1 = document.getElementsByClassName("esri-attribution__powered-by");
            for (var i = 0; i < displaynoneDiv1.length; i++) {
                displaynoneDiv1[i].style.display = "none"
            }

            let m_zoom = new Zoom({
                view: m_view
            });

            //m_view.ui.padding={right:0,bottom:0};
            m_view.popup.autoOpenEnabled=true;
            m_view.ui.move(["zoom", m_zoom], "top-right");

            //m_view.ui.remove('zoom');
            //m_view.ui.remove('attribution');
            m_drawtool = new Draw({
                view: m_view
            });
            addToolbox();//增加按钮
            createTLDiv();//图例
            mapLoaded();
        });
        //显示经纬度坐标
        m_view.on("click", (event) => {
            let lat = Math.round(event.mapPoint.latitude * 1000) / 1000;
            let lon = Math.round(event.mapPoint.longitude * 1000) / 1000;
            console.log(lon + ", " + lat);
            var screenPoint = {
                x: event.x,
                y: event.y
            };
            var hitPoint = m_view.toMap(screenPoint);
            m_view.hitTest(screenPoint).then(function(response) {
                console.log(response);
                if(response.results){
                    for(let i=0;i<response.results.length;i++){
                        if(response.results[i].graphic.layer.id=="myLabelGLayer"){
                            highlightGraphic(GraphicsLayer_labelLayer,response.results[i].graphic);
                            myLabelGLayerClick(response.results[i].graphic);

                        }
                    }
                }
            });

        });

        function AddMapGraphicLayers() {
            GraphicsLayer_labelLayer = new GraphicsLayer({id:"myLabelGLayer"});
            GraphicsLayer_labelLayer.listMode = "hide";
            GraphicsLayer_myLayer = new GraphicsLayer({id:"myGLayer"});
            GraphicsLayer_myLayer.listMode = "hide";
            GraphicsLayer_identityLayer = new GraphicsLayer;
            GraphicsLayer_identityLayer.listMode = "hide";
            GraphicsLayer_extendLayer = new GraphicsLayer;
            GraphicsLayer_extendLayer.listMode = "hide";
            GraphicsLayer_fickerLayer = new GraphicsLayer;
            GraphicsLayer_fickerLayer.listMode = "hide";
            GraphicsLayer_DrawLayer = new GraphicsLayer({id:"myDrawGLayer"});
            GraphicsLayer_DrawLayer.listMode = "hide";
            GraphicsLayer_flyTipLayer = new GraphicsLayer;
            GraphicsLayer_flyTipLayer.listMode = "hide";
            m_map.add(GraphicsLayer_labelLayer);
            m_map.add(GraphicsLayer_identityLayer);
            m_map.add(GraphicsLayer_DrawLayer);
            m_map.add(GraphicsLayer_flyTipLayer);
            m_map.add(GraphicsLayer_myLayer);
            m_map.add(GraphicsLayer_extendLayer);
            m_map.add(GraphicsLayer_fickerLayer);

        }

    });
}


var ecxtentChanged;

function addFeatureLayerByGraphics(GraphicsArray,fid,where,featureID) {
//增加视频点
    require(["esri/layers/FeatureLayer","esri/layers/support/Field","esri/renderers/HeatmapRenderer","esri/Graphic"], function(FeatureLayer,Field,HeatmapRenderer,Graphic) {
        var geometryType = "point";
        var templateInfo={
            title: "{POINT_NAME}",
            content:setContentInfo
        }

        if(where){
            if(where.length>0){
                where+=" and canplay=1";
            }
            featureLayerCamera= new FeatureLayer({
                // URL to the service
                id:"fc"+featureID,
                geometryType:geometryType,
                objectIdField:"OBJECTID",
                source: GraphicsArray,
                fields: fields,
                outFields: ["*"],
                opacity:0.8,
                spatialReference:m_view.spatialReference
            });
            featureLayerCamera.renderer = {
                type: "simple",  // autocasts as new SimpleRenderer()
                symbol: {
                    type: "picture-marker",  // autocasts as new PictureMarkerSymbol()
                    url: getRootPath_web()+"/img/symbol/camera"+featureID+".png",
                    width: "20px",
                    height: "20px"
                }
            };
        }
        else{
            featureLayerCamera= new FeatureLayer({
                // URL to the service
                url: serviceURL+"/"+fid,
                outFields:["*"],
                opacity:0.8
            });
        }

        featureLayerCamera.popupEnabled=true;
        featureLayerCamera.popupTemplate=templateInfo;
        m_map.add(featureLayerCamera);
        featureLayerCamera.on("layerview-create", function(event){
            // The LayerView for the layer that emitted this event
            // refrashLegend();
        });
    });
}

function removeFeatureLayerCamera(featureID) {
    if(featureLayerCamera){
        if(featureID){
            m_map.remove(m_map.findLayerById("fc"+featureID));
        }
        else{
            $("#divCamera .second_icon").each(function () {
                var vid=$(this).attr("vid");
                m_map.remove(m_map.findLayerById("fc"+vid));
            })
        }

    }
    m_view.popup.close();
}

function AddFeatureLayerByData(layerDataArray,renderer,labelingInfo,id,fields,clusterConfig) {
    require(["esri/layers/FeatureLayer","esri/layers/support/Field","esri/renderers/HeatmapRenderer","esri/Graphic"], function(FeatureLayer,Field,HeatmapRenderer,Graphic) {
        var graphics = [];
        for(var i=0;i<layerDataArray.length;i++){
            var geometry;
            var attribute;
            if(layerDataArray[i].geometry){
                geometry = layerDataArray[i].geometry;
            }
            else{
                geometry = {
                    type: "point",  // autocasts as new Point()
                    x: parseFloat(layerDataArray[i].住址x),
                    y: parseFloat(layerDataArray[i].住址y),
                    spatialReference:m_view.spatialReference
                };
            }
            if(layerDataArray[i].attributes)
                attribute = layerDataArray[i].attributes;
            else
                attribute = layerDataArray[i];
            var g1=new Graphic({
                geometry: geometry,
                attributes: attribute
            });
            graphics.push(g1);
        }
        var geometryType = "point";
        if(layerDataArray[0].geometry ){
            geometryType = layerDataArray[0].geometry.type;
        }
        var layer = new FeatureLayer({
            geometryType:geometryType,
            objectIdField:"OBJECTID",
            source: graphics,
            fields: fields,
            renderer:renderer,
            labelingInfo:labelingInfo,
            id:id,
            outFields: ["*"],
            spatialReference:m_view.spatialReference
        });

        // if(clusterConfig != undefined)
        //     layer.featureReduction = clusterConfig ;
        m_view.map.add(layer);
    });
}

function AddGraphicDataToGraphicLayer(graphicDataArray,drawGraphicLayer) {
    require(["esri/Graphic"], function (Graphic) {
        let graphicArray = [];
        for (let i = 0; i < graphicDataArray.length; i++) {
            let graphicData = graphicDataArray[i];
            let attributes = graphicData;
            let symbol;
if(!graphicData.geomt){
    break;
}
            let geometry = GetGeomtryFormPostgis(JSON.parse(graphicData.geomt));

            switch (geometry.type) {
                case "polygon": {
                    symbol = {
                        type: "simple-fill",  // autocasts as SimpleLineSymbol()
                        color: [51, 51, 204, 0.2],
                        style: "diagonal-cross",
                        outline: {  // autocasts as new SimpleLineSymbol()
                            color:  [51, 51, 204, 0.5],
                            width: 1
                        }
                    };
                    break;
                }
                case "polyline": {
                    symbol = {
                        type: "simple-line",
                        color: [226, 119, 40],
                        width: 4
                    };
                    break;
                }
                case "point": {
                    symbol = {
                        type: "simple-marker",
                        color: [226, 119, 40]
                    };
                    break;
                }
            }
            let graphic = new Graphic({
                geometry: geometry,
                symbol: symbol,
                attributes: attributes,
                spatialReference: m_view.spatialReference
            });
            graphicArray.push(graphic);
        }
        if(graphicArray.length>0){
            drawGraphicLayer.addMany(graphicArray);
            m_view.goTo(graphicArray[0]);
        }

    });
}

function PARSE_STRING_ARRAY(str) {

        let right = null;
        let parent = null;

        let key = "";
        let value = "";

        for (let i = 0; i < str.length; i++) {
            const letter = str[i];

            if (letter === "[") {
                right = "]";
                parent = new Array();
            } else if (letter === "]") {
                if (right === letter && value) {
                    parent.push(value);
                    value = "";
                    right = null;
                }
            } else if (letter === ",") {
                if (right === "]") {
                    parent.push(value);
                    value = "";
                }
            } else {
                // non empty
                if (letter && letter !== " ") {
                    value += letter;
                }
            }
        }
        return parent;


}

function GetPostgisFromGeomtry(geometry) {
    let geomStr="";
    switch (geometry.type) {
        case "polygon":{
            let ring1=[];

            let rings=geometry.rings;
            for(let i=0;i<rings.length;i++){
                let ring2=[];
                for(let j=0;j<rings[i].length;j++){
                    ring2.push(rings[i][j][0].toString()+" "+rings[i][j][1].toString());
                    if(j==(rings[i].length-1)){
                        if((rings[i][j][0].toString()+" "+rings[i][j][1].toString()!=(rings[i][0][0].toString()+" "+rings[i][0][1].toString()))){
                            ring2.push(rings[i][0][0].toString()+" "+rings[i][0][1].toString());
                        }
                    }
                }
                ring1.push(ring2);
            }
            let ringStr=JSON.stringify(ring1).replace(/\[/g,"(").replace(/\]/g,")").replace(/"/g,"");
            geomStr="POLYGON "+ringStr;

            break;
        }
        case "point":{
            geomStr="POINT("+geometry.x+" "+geometry.y+")";
            break;
        }
    }
    return geomStr;
}

function GetGeomtryFormPostgis(geomData) {
    let newgeometry;
    require(["esri/geometry","esri/geometry/Polygon","esri/geometry/Polyline","esri/geometry/Point"], (geometry,Polygon,Polyline,Point) => {
        let keyword=geomData.type;
        switch (keyword) {
            case "MultiPolygon":{
                let ringPointsArray=geomData.coordinates;
                let rings=[];
                for(let i=0;i<ringPointsArray.length;i++){
                    rings.push(ringPointsArray[i][0]);
                }
                newgeometry=new Polygon({
                    rings:rings,
                    spatialReference:m_view.spatialReference
                });
                break;
            }
            case "Polygon":{
                let ringPointsArray=geomData.coordinates;
                let rings=[];
                for(let i=0;i<ringPointsArray.length;i++){
                    rings.push(ringPointsArray[i]);
                }
                newgeometry=new Polygon({
                    rings:rings,
                    spatialReference:m_view.spatialReference
                });
                break;
            }
            case "MultiLineString":{
                let ringPointsArray=geomData.coordinates;
                newgeometry=new Polyline({
                    paths:ringPointsArray,
                    spatialReference:m_view.spatialReference
                });
                break;
            }
            case "Point":{
                let pointArray=geomData.coordinates;
                newgeometry=new Point({
                    x:pointArray[0],
                    y:pointArray[1],
                    spatialReference:m_view.spatialReference
                });
                break;
            }
        }

    });
    return newgeometry;

}

function createGraphic(geomtry,attributes,symbol,popupTemplate) {
    let newGraphic;
    let newSymbol;
    require(["esri/Graphic","esri/geometry/Polygon","esri/geometry/Polyline","esri/geometry/Point"], (Graphic,Polygon,Polyline,Point) => {
        if(symbol){
            newSymbol=symbol;
        }else{
            switch (geomtry.type) {
                case "point":{
                    newSymbol= {
                        type: "simple-marker",
                        color: [226, 119, 40]
                    };
                    break;
                }
                case "polyline":{
                    newSymbol = {
                        type: "simple-line",
                        color: [226, 119, 40],
                        width: 4
                    };
                    break;
                }
                case "polygon":{
                    newSymbol = {
                        type: "simple-fill",  // autocasts as SimpleLineSymbol()
                        color: [51, 51, 204, 0.2],
                        style: "solid",
                        outline: {  // autocasts as new SimpleLineSymbol()
                            color:  [51, 51, 204, 0.5],
                            width: 1
                        }
                    };
                    break;
                }

            }
        }

        if(popupTemplate){
            newGraphic=new Graphic({
                geometry:geomtry,
                attributes:attributes,
                symbol: newSymbol,
                popupTemplate:popupTemplate
            });
        }
        else{
            newGraphic=new Graphic({
                geometry:geomtry,
                attributes:attributes,
                symbol: newSymbol
            });
        }


    });
    return newGraphic;
}

function createGraphicFromRings(type,rings,attributes) {
    let newGraphic;
    require(["esri/Graphic","esri/geometry/Polygon","esri/geometry/Polyline","esri/geometry/Point"], (Graphic,Polygon,Polyline,Point) => {
        let newgeomtry;
        let newSymbol;
        switch (type) {
            case "point":{
                newgeomtry=new Point({
                    x:rings[0][0],
                    y:rings[0][1],
                    spatialReference:m_view.spatialReference
                });
                newSymbol= {
                    type: "simple-marker",
                    color: [226, 119, 40]
                };
                break;
            }
            case "polyline":{
                newgeomtry=new Polyline({
                    paths:rings,
                    spatialReference:m_view.spatialReference
                });
                newSymbol = {
                    type: "simple-line",
                    color: [226, 119, 40],
                    width: 4
                };
                break;
            }
            case "rectangle":{
                let paths=[];
                // debugger
                if(rings.length==2){

                    paths.push([rings[0][0],rings[0][1]]);
                    paths.push([rings[1][0],rings[0][1]]);
                    paths.push([rings[1][0],rings[1][1]]);
                    paths.push([rings[0][0],rings[1][1]]);
                    paths.push([rings[0][0],rings[0][1]]);
                }

                newgeomtry=new Polygon({
                    rings:paths,
                    spatialReference:m_view.spatialReference
                });
                newSymbol = {
                    type: "simple-fill",  // autocasts as SimpleLineSymbol()
                    color: [51, 51, 204, 0.2],
                    style: "solid",
                    outline: {  // autocasts as new SimpleLineSymbol()
                        color:  [51, 51, 204, 0.5],
                        width: 1
                    }
                };
                break;
            }
            case "polygon":{
                newgeomtry=new Polygon({
                    rings:rings,
                    spatialReference:m_view.spatialReference
                });
                newSymbol = {
                    type: "simple-fill",  // autocasts as SimpleLineSymbol()
                    color: [51, 51, 204, 0.2],
                    style: "solid",
                    outline: {  // autocasts as new SimpleLineSymbol()
                        color:  [51, 51, 204, 0.5],
                        width: 1
                    }
                };
                break;
            }

        }
        newGraphic=new Graphic({
            geometry:newgeomtry,
            attributes:attributes,
            symbol: newSymbol
        });
    });
    return newGraphic;
}

function queryPostgisData(fields,tableName,whereStr,geomText) {
    var sql="select "+fields+",st_asgeojson(t.geom) as geomt from "+tableName+" t where "+whereStr;
    if(geomText){
        sql+=" and st_intersects(ST_GeometryFromText('"+geomText+"'),geom)='t'";
    }
    WsCommonClass("QueryDataBaseJson",["sql"],[sql],mapQueryProjectSucess,"queryPostgisData",false);
}

function mapQueryProjectSucess(evt,keyValue,extraData) {
    let allCount;
    let pageIndex;
    let msg;
    let jsonArray;
    let currentCount;

    if (evt != null) {
        allCount = evt.AllCount;
        pageIndex = evt.pageIndex;
        jsonArray = evt.data;
        currentCount = evt.CurrCount;
        msg = evt.Msg;
    }
    switch (keyValue) {
        case "queryPostgisData":{
            let returnGraphicArray=[];
            for(let i=0;i<jsonArray.length;i++){
                let geom=GetGeomtryFormPostgis(JSON.parse(jsonArray[i].geomt));

                returnGraphicArray.push(createGraphic(geom,jsonArray[i]));
            }
            GraphicsLayer_myLayer.removeAll();
            AddGraphicDataToGraphicLayer(jsonArray,GraphicsLayer_myLayer);
            showitemsData(jsonArray,"divSelectData");
            //GraphicsLayer_extendLayer.addMany(returnGraphicArray);

            //highlightGraphic(GraphicsLayer_myLayer,returnGraphicArray);
            break;
        }
    }
}

function highlightGraphic(layer,graphics) {
    m_view.whenLayerView(layer).then(function(lyrView) {
        if (highlightSelect) {
            highlightSelect.remove();
        }
        highlightSelect = lyrView.highlight(graphics);
    });
}

function fullSight() {
    //全景
    require(["esri/geometry/Point","esri/geometry/SpatialReference"], (Point,SpatialReference) => {
        var cityCenter = new Point(109.507, 18.256, new SpatialReference({ wkid: 4490 }));
        m_view.zoom=12;
        m_view.goTo(cityCenter);
    });

}

function ClearMap() {
    GraphicsLayer_labelLayer.removeAll();
    GraphicsLayer_myLayer.removeAll();
    GraphicsLayer_identityLayer.removeAll();
    GraphicsLayer_extendLayer.removeAll();
    GraphicsLayer_fickerLayer.removeAll();
    GraphicsLayer_DrawLayer.removeAll();
    GraphicsLayer_flyTipLayer.removeAll();
    m_view.graphics.removeAll();
    m_view.popup.close();
}

//气泡
var popupInfos= [];

//初始化列表
function popupInit(popupInfoArray,funcType){
    m_view.when(function(){
        //监听地图变化事件，对应刷新气泡窗口位置
        m_view.watch("extent", function () {
            relocatePopup();
        });
        m_view.watch("rotation", function () {
            relocatePopup();
        });
        //地图加载完，初始化气泡窗口

    });
    //popup初始化
    popupInfos=popupInfoArray;

    for (var i = 0; i < popupInfos.length; i++) {
        var popupInfo = popupInfos[i];
        //坐标转换
        var mapPoint = {
            x: popupInfo.x,
            y: popupInfo.y,
            spatialReference: m_view.spatialReference
        };
        var screenPoint = m_view.toScreen(mapPoint);
        var obj = {};
        obj.x =screenPoint.x;
        obj.y =screenPoint.y;
        obj.content = popupInfo.content;
        obj.id = popupInfo.id;
        if(funcType==1){
            loadinfoWindow(obj);
        }else{
            loadinfoWindow2(obj);
        }

    }

}

function relocatePopup(e) {
    for (var i = 0; i < popupInfos.length; i++) {
        var popupInfo = popupInfos[i];
        //坐标转换
        var mapPoint = {
            x: popupInfo.x,
            y: popupInfo.y,
            spatialReference: m_view.spatialReference
        }
        var screenPoint = m_view.toScreen(mapPoint);
        var obj = {};
        obj.x = screenPoint.x;
        obj.y = screenPoint.y;
        obj.content = popupInfo.content;
        obj.id = popupInfo.id;
        //刷新气泡窗口位置
        positionPopUp(obj);
    }

}
//显示所有气泡窗口
function popupShowAll(){
    for (var i = 0; i < popupInfos.length; i++) {
        var popupInfo = popupInfos[i];
        showinfoWindow(popupInfo.id);
    }
}

//隐藏所有气泡窗口
function popupCloseAll(){
    for (var i = 0; i < popupInfos.length; i++) {
        var popupInfo = popupInfos[i];
        hideinfoWindow(popupInfo.id);
    }
}

function loadinfoWindow(obj){
    //动态添加气泡窗口DIV
    var infoDiv = '<div id="trackPopUp'+obj.id+'" class="leaflet-popup" style="top:0px;left:0px;">'+
        // '<a class="leaflet-popup-close-button" id="leaflet-popup-close'+obj.id+'" href="#">×</a>'+
        '<div class="leaflet-popup-content-wrapper">'+
        '<div id="'+obj.id+'" class="leaflet-popup-content" style="max-width: 300px;"></div>'+
        '</div>'+
        '<div class="leaflet-popup-tip-container">'+
        '<div class="leaflet-popup-tip"></div>'+
        '</div>'+
        '</div>';
    $("#mapDiv").append(infoDiv);
    //填充内容
    $('#'+obj.id).append(obj.content);
    //刷新气泡窗口位置
    positionPopUp(obj);
    //气泡窗口关闭事件
    $('#leaflet-popup-close'+obj.id).click(function() {
        $('#trackPopUp'+obj.id).hide();
        // let el=$(obj.content);
        // let index=($(el[0]).attr("value"));
        // hidInfoDetail(index);
    });
}

function loadinfoWindow2(obj){
    //动态添加气泡窗口DIV
    var infoDiv = '<div id="trackPopUp'+obj.id+'" class="leaflet-popup" style="top:-25px;left:0px;">'+
        '<a class="leaflet-popup-close-button" id="leaflet-popup-close'+obj.id+'" href="#">×</a>'+
        '<div class="leaflet-popup-content-wrapper">'+
        '<div id="'+obj.id+'" class="leaflet-popup-content" style="max-width: 300px;"></div>'+
        '</div>'+
        '<div class="leaflet-popup-tip-container">'+
        '<div class="leaflet-popup-tip"></div>'+
        '</div>'+
        '</div>';
    $("#mapDiv").append(infoDiv);
    //填充内容
    $('#'+obj.id).append(obj.content);
    //刷新气泡窗口位置
    positionPopUp(obj);
    //气泡窗口关闭事件
    $('#leaflet-popup-close'+obj.id).click(function() {
        //$('#trackPopUp'+obj.id).hide();
        let el=$(obj.content);
        let index=($(el[0]).attr("value"));
        hidInfoDetail(index);
    });
}

//显示指定气泡窗口
function showinfoWindow(id){
    $('#trackPopUp'+id).show();
}
//隐藏指定气泡窗口
function hideinfoWindow(id){
    $('#trackPopUp'+id).remove();
}

function positionPopUp(obj){
    var o=document.getElementById("trackPopUp"+obj.id);
    if(o){
        var w = o.clientWidth||o.offsetWidth;
        var h=o.clientHeight||o.offsetHeight;
        $('#trackPopUp'+obj.id).css('transform', 'translate3d(' + (obj.x-(w/2)) + 'px, ' + (obj.y-(h)) + 'px, 0)');
    }

}

function colorRgba(sHex, alpha) {
    // 十六进制颜色值的正则表达式
    var reg = /^#([0-9a-fA-f]{3}|[0-9a-fA-f]{6})$/
    /* 16进制颜色转为RGB格式 */
    var sColor = sHex.toLowerCase()
    if (sColor && reg.test(sColor)) {
        if (sColor.length === 4) {
            var sColorNew = '#'
            for (var i = 1; i < 4; i += 1) {
                sColorNew += sColor.slice(i, i + 1).concat(sColor.slice(i, i + 1))
            }
            sColor = sColorNew
        }
        //  处理六位的颜色值
        var sColorChange = []
        for (var i = 1; i < 7; i += 2) {
            sColorChange.push(parseInt('0x' + sColor.slice(i, i + 2)))
        }
        // return sColorChange.join(',')
        // 或
        return 'rgba(' + sColorChange.join(',') + ',' + alpha + ')'
    } else {
        return sColor;
    }
}

//增加图例
function createTLDiv() {
    let infoDiv=document.createElement("div");
    $(infoDiv).attr("id","info");
    $(infoDiv).addClass("panel panel-info");
    $(infoDiv).attr("style","opacity: 0.75;visibility: hidden;");
    let heading=document.createElement("div");
    $(heading).addClass("panel-heading");
    let title=document.createElement("h3");
    $(title).addClass("panel-title");
    let closeButton=document.createElement("span");
    $(closeButton).addClass("esri-icon esri-icon-close pull-right form-inline");
    $(closeButton).attr("style","cursor:pointer");
    $(closeButton).on("click",function (){
        $("#info").attr("style","visibility: hidden;opacity: 0.75;");
    });
    $(title).html("图例");
    $(title).append(closeButton);
    $(heading).append(title);
    $(infoDiv).append(heading);
    let img=document.createElement("img");
    $(img).attr("src","assets/images/计生委图例.jpg");
    $(infoDiv).append(img);
    m_view.ui.add(infoDiv, "bottom-right");
}

//增加工具栏按钮
function addToolbox(){
    require(["esri/geometry/Point","esri/widgets/Compass","esri/geometry/SpatialReference"],
        function(Point,Compass,SpatialReference) {
        //全景
            let f2=document.createElement("div");
            $(f2).attr("class","esri-component esri-widget");
            let f2b=document.createElement("div");
            $(f2b).attr("class","esri-widget--button esri-widget esri-interactive");
            $(f2b).attr("title","全景");
            $(f2b).html("<span class='esri-icon esri-icon-public'></span>");
            $(f2b).bind("click",function (event) {
                let cityCenter = new Point(121.472, 31.233, new SpatialReference({ wkid: 4490 }));
                m_view.zoom=9;
            })
            $(f2).append(f2b);
            m_view.ui.add(f2,"top-right");
            //图例
            let f1=document.createElement("div");
            $(f1).attr("class","esri-component esri-widget");
            let f1b=document.createElement("div");
            $(f1b).attr("class","esri-widget--button esri-widget esri-interactive");
            $(f1b).attr("title","图例");
            $(f1b).html("<span class='esri-icon esri-icon-legend'></span>");
            $(f1b).bind("click",function (event) {
                $("#info").attr("style","visibility: block;opacity: 0.75;");
            })
            $(f1).append(f1b);
            m_view.ui.add(f1,"top-right");
            //清空地图
            let f3=document.createElement("div");
            $(f3).attr("class","esri-component esri-widget");
            let f3b=document.createElement("div");
            $(f3b).attr("class","esri-widget--button esri-widget esri-interactive");
            $(f3b).attr("title","清空地图");
            $(f3b).html("<span class='esri-icon esri-icon-refresh'></span>");
            $(f3b).bind("click",function (event) {
                ClearMap();
            })
            $(f3).append(f3b);
            m_view.ui.add(f3,"top-right");
            //$(".esri-ui-top-right").append(f3);
            //指南针
            var m_compass = new Compass({
                view: m_view
            });
            m_view.ui.add(m_compass, {
                position: "top-right"
            });
        });


}
